//1_FormateMuster_203d.js
// 28.01.09 / Hans Haesler, Chtelard 52, CH-1018 Lausanne / <hsa@ringier.ch>
//Dient zum Erzeugen eines Musters aller Absatz- und Zeichenformate

if (app.documents.length == 0) {
	alert ("Es ist kein Dokument offen.", "Achtung");
	exit();
}

// eine Referenz des vordersten Dokuments
var curDoc = app.documents[0];

// den ersten Druckbogen anzeigen und die Seite einpassen
app.activeWindow.activeSpread = curDoc.spreads[0];
app.activeWindow.zoom(ZoomOptions.fitPage); 

// den Nullpunkt auf Null/Null setzen
app.documents[0].zeroPoint = [0,0];

// die Sperrung der Ebenen speichern und aufheben (falls notwendig)
var allLayers = curDoc.layers;
var nLayers = allLayers.length;
var layerLocks = new Array ();
for (var i=0; i<nLayers; i++) {
	if (allLayers[i].locked == true) {
		allLayers[i].locked = false;
		layerLocks.push(true);
		}
	else {
		layerLocks.push(false);
	}		
}

// die Rahmen entfernen, falls sie vorhanden sind (sonst wird mit 
// dem SchriftenZuweisen-Script eine Fehlermeldung gezeigt)
try {
	curDoc.textFrames.item("paraStyles").remove();
}
catch (e) {
}
try {
	curDoc.textFrames.item("charStyles").remove();
}
catch (e) {
}

// die Vorgaben-Einstellungen der Formate festlegen
try {
	var eaParaStyle = curDoc.paragraphStyles.item(1);
	var noCharStyle = curDoc.characterStyles.item(0);
	curDoc.textDefaults.appliedParagraphStyle = eaParaStyle;
	curDoc.textDefaults.appliedCharacterStyle = noCharStyle;
}
catch (e) {
}

// die Grsse der Seite feststellen und die Parameter vorbereiten
var pageSize = curDoc.pages[0].bounds;
var y1 = pageSize[0];
var x1 = pageSize[1];
var y2 = pageSize[2];
var x2 = pageSize[3];
var h1 = (y2-y1)/5;

// eine Referenz zum Farbfeld "Papier" definieren
var whiteColor = curDoc.swatches.item("Paper");

// einen Textrahmen erzeugen, benennen und die Hintergrundfarbe zuweisen
var paraFrame = curDoc.pages[0].textFrames.add({geometricBounds:[y1,x1,h1*3,x2], 
	label:"paraStyles", fillColor:whiteColor});

//**********************************
//--- die Absatzformatnamen einsetzen und das entsprechende Format anwenden ---//
var allParaStyles = curDoc.paragraphStyles;
var paraCount = allParaStyles.length;

var paraStory = paraFrame.parentStory;
var paraStyle;
// als erstes Element wird "1" eingefgt (statt "0"), damit 
// "Kein Absatzformat" ausgeklammert wird (nicht per Script editierbar) 
paraStory.contents = allParaStyles[1].name;
paraStory.paragraphs[0].appliedParagraphStyle = allParaStyles[1];
// eine Schleife durch den Rest der Liste
for (var i=2; i<paraCount; i++) {
	paraStyle = allParaStyles[i].name;
	paraStory.insertionPoints[-1].contents = "\r" + paraStyle;
	try {
		paraStory.paragraphs.item(i-1).appliedParagraphStyle = paraStyle;
	}
	catch (e) {
	}
}

// einen Textrahmen erzeugen, benennen und die Hintergrundfarbe zuweisen
var charFrame = curDoc.pages[0].textFrames.add({geometricBounds:[h1*3,x1,y2,x2], 
	label:"charStyles", fillColor:whiteColor});

//**********************************
//--- die Zeichenformatnamen einsetzen und das entsprechende Format anwenden ---//

var allCharStyles = curDoc.characterStyles;
var charCount = allCharStyles.length;
var charStory = charFrame.parentStory;
var charStyle;
// wie oben wird mit dem zweiten Element begonnen, weil 
// "Kein Zeichenformat" nicht per Script gendert werden kann
try {
	charStory.contents = allCharStyles[1].name;
	charStory.paragraphs[0].appliedParagraphStyle = eaParaStyle;
	charStory.paragraphs[0].appliedCharacterStyle = allCharStyles[1];
}
catch (e) {
}
// eine Schleife durch den Rest der Liste
for (var i=2; i<charCount; i++) {
	// das Zeichenformat wird nur aufgelistet, wenn eine Schrift definiert ist
	if (allCharStyles[i].appliedFont != "") {
		charStyle = allCharStyles[i].name;
		charStory.insertionPoints[-1].contents = "\r" + charStyle;
		try {
			charStory.paragraphs.item(-1).appliedCharacterStyle = charStyle;
		}
		catch (e) {
		}
	}
}

// die Sperrung der Ebenen wiederherstellen (falls notwendig)
for (var i=0; i<nLayers; i++) {
	allLayers[i].locked = layerLocks[i];
}